package com.persagy.iot.func

import com.persagy.iot.bean.IOTData
import org.apache.flink.api.common.state.{ValueState, ValueStateDescriptor}
import org.apache.flink.streaming.api.functions.KeyedProcessFunction
import org.apache.flink.util.Collector

class OriginalDataAlarm extends KeyedProcessFunction[String, IOTData, IOTData] {

  lazy val alarmTimeState: ValueState[Long] = getRuntimeContext.getState(new ValueStateDescriptor[Long]("alarm-time", classOf[Long]))

  override def processElement(iotData: IOTData,
                              ctx: KeyedProcessFunction[String, IOTData, IOTData]#Context,
                              out: Collector[IOTData]): Unit = {
    val alarmTime: Long = iotData.eventTime + 1000 * 60 * 60
    ctx.timerService().registerEventTimeTimer(alarmTime)
    alarmTimeState.update(iotData.eventTime)
  }

  override def onTimer(timestamp: Long,
                       ctx: KeyedProcessFunction[String, IOTData, IOTData]#OnTimerContext,
                       out: Collector[IOTData]): Unit = {

  }
}
